using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

using SpatialAnalyzerSDK;

namespace SDKTesterCSharp
{
    public partial class Form1 : Form
    {
        ISpatialAnalyzerSDK NRKSdk = null; //new SpatialAnalyzerSDKClass();

        enum MPStatus
        {
            SdkError = -1,
            Undone = 0,
            InProgress = 1,
            DoneSuccess = 2,
            DoneFatalError = 3,
            DoneMinorError = 4,
            CurrentTask = 5
        };

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //KillExistingSASDK();

            if (NRKSdk == null)
            {
                System.Type objType = System.Type.GetTypeFromProgID("SpatialAnalyzerSDK.Application");
                dynamic comObject = System.Activator.CreateInstance(objType);
                NRKSdk = (ISpatialAnalyzerSDK)comObject;
            }
            int statusCode = 0;
            String host = "localhost";
            if (!NRKSdk.ConnectEx(host, ref statusCode))
	        {
		        //MessageBox.Show("Unable to Connect!");
                MessageBox.Show("Unable to Connect: " + statusCode); 
	        }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (NRKSdk == null)
            {
                return;
            }
            
            NRKSdk.SetStep("Make a Collection Object Name Ref List - By Type");
            NRKSdk.SetStringArg("Collection", "A");
            NRKSdk.SetObjectTypeArg("Object Type", "Frame");
            bool bSendStatus = NRKSdk.ExecuteStep();

            if (bSendStatus)
            {
                Object objNameList = null;
                if (NRKSdk.GetCollectionObjectNameRefListArg("Resultant Collection Object Name List", ref objNameList))
                {
	                string msg = "";
                    Array sNames = (Array)objNameList;
                    foreach (string str in sNames)
                    {
                        System.Console.WriteLine(str);
                        msg += str;
	                    msg += "\n";
                    }
	                MessageBox.Show(msg);
                }
            }

            NRKSdk.SetStep("Make a Collection Object Name Reference List- Runtime Select");
            NRKSdk.SetStringArg("User Prompt", "Pick anything");
            // Available options: 
            // "Any", "Circle", "Cloud", "Cone", "Curves", 
            // "Cylinder", "Ellipse", "Frame", "Line", "Paraboloid", 
            // "Perimeter", "Plane", "Point Group", "Poly Surface", "Sphere", 
            // "Spline", "Surface", "Vector Group", 
            NRKSdk.SetObjectTypeArg("Object Type", "Any");
            bSendStatus = NRKSdk.ExecuteStep();

            if (bSendStatus)
            {
                Object vUserObjList = null;
                if (NRKSdk.GetCollectionObjectNameRefListArg("Resultant Collection Object Name Reference List", ref vUserObjList))
                {
                    string msg = "";
                    Array msgs = (Array)vUserObjList;
                    for (int i = 0; i < msgs.Length; i++)
                    {
                        msg += (String)msgs.GetValue(i);
                        msg += "\n";
                        //Console.WriteLine(msg);
                    }
                    MessageBox.Show(msg);
                }
            }


			// olga XIT-1135 - multi-line text
	        object myNotes = new System.Collections.ArrayList();
	        ((System.Collections.ArrayList)myNotes).Add("Line 1");
	        ((System.Collections.ArrayList)myNotes).Add("Line 2");
	        ((System.Collections.ArrayList)myNotes).Add("Line 3");

            Object vMyNotesList = new System.Runtime.InteropServices.VariantWrapper(((System.Collections.ArrayList)myNotes).ToArray());

            // Set Object Notes
            NRKSdk.SetStep("Set Object Notes");
	        NRKSdk.SetCollectionObjectNameArg("Object", "A", "World");
            NRKSdk.SetEditTextArg("Notes", vMyNotesList);
	        bSendStatus = NRKSdk.ExecuteStep();

            // Notify User Text Array
	        NRKSdk.SetStep("Notify User Text Array");	
	        NRKSdk.SetEditTextArg("Notification Text", vMyNotesList);
	        NRKSdk.SetFontTypeArg("Font", "MS Shell Dlg", 8, 0, 0, 0);
	        NRKSdk.SetBoolArg("Auto expand to fit text?", false);
	        NRKSdk.SetIntegerArg("Display Timeout", 0);
	        bSendStatus = NRKSdk.ExecuteStep();


            //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Research code below...
            object instObjList = new System.Collections.ArrayList();
            ((System.Collections.ArrayList)instObjList).Add("Survey::Cartesian Z 2.000000 in");
            ((System.Collections.ArrayList)instObjList).Add("Survey::Cartesian Z 4.000000 in");
            ((System.Collections.ArrayList)instObjList).Add("Survey::Fitted Circle");
            //((System.Collections.ArrayList)instObjList).Add("References::3");
            //((System.Collections.ArrayList)instObjList).Add("References::4");
            //((System.Collections.ArrayList)instObjList).Add("References::5");

            //String[] objList = new String[2];
            //objList[0] = "A::0";
            //objList[1] = "A::1";

            Object vMyObjList = new System.Runtime.InteropServices.VariantWrapper(((System.Collections.ArrayList)instObjList).ToArray());

            NRKSdk.SetStep("Hide Objects");
            NRKSdk.SetCollectionObjectNameRefListArg("Objects To Hide", vMyObjList);
            NRKSdk.ExecuteStep();

            object instList = new System.Collections.ArrayList();
            ((System.Collections.ArrayList)instList).Add("A::0");
            ((System.Collections.ArrayList)instList).Add("A::1");
            ((System.Collections.ArrayList)instList).Add("A::2");
            ((System.Collections.ArrayList)instList).Add("A::3");

            Object vInstList = new System.Runtime.InteropServices.VariantWrapper(((System.Collections.ArrayList)instList).ToArray());

            NRKSdk.SetStep("Locate Instruments (USMN)");
            NRKSdk.SetColInstIdRefListArg("Instruments to Locate", ref vInstList);
            NRKSdk.SetCollectionObjectNameArg("Nominals Group Name (blank for none)", "", "");
            NRKSdk.SetCollectionObjectNameArg("Output Group Name (to be established)", "USMN Data", "composite result");
            NRKSdk.SetBoolArg("AutoReject Outliers and Resolve", false);
            NRKSdk.SetShowUsmnDialogTypeArg("Show USMN Dialog", "Yes");
            NRKSdk.SetDoubleArg("Max Acceptable RMS Error Value (0.0 for none)", 0.000000);
            NRKSdk.SetDoubleArg("Max Acceptable Error Value (0.0 for none)", 0.000000);
            bSendStatus = NRKSdk.ExecuteStep();

            if (bSendStatus)
            {
                int rCode = 0;
                NRKSdk.GetMPStepResult(ref rCode);
                if (rCode == (int)MPStatus.SdkError)
                {
                    //CStringArray msgs;
                    //// Something went wrong... check for any messages provided...
                    Object obj = null;
                    if (NRKSdk.GetMPStepMessages(ref obj))
                    {
                        string msg = "";
                        Array msgs = (Array)obj;
                        for (int i = 0; i < msgs.Length; i++)
                        {
                            msg += (String)msgs.GetValue(i);
                            msg += "\n";
                            //Console.WriteLine(msg);
                        }
                        MessageBox.Show(msg);
                    }
                }
            }
            //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
            // AddFunctTreeItem(MP_CONSTRUCT_POINT,_T("Construct a Point in Working Coordinates"),IDI_MP_DEFAULT,TRUE,ret2);
            // AddFunctArg(MP_CONSTRUCT_POINT,MP_ARG_POINT_NAME,_T("Point Name"));
            // AddFunctArg(MP_CONSTRUCT_POINT,MP_ARG_VECTOR,_T("Working Coordinates"));
            NRKSdk.SetStep("Construct a Point in Working Coordinates");
            NRKSdk.SetVectorArg("Working Coordinates", 10.1234, 20.2345, 30.5678);
            NRKSdk.SetPointNameArg("Point Name", "", "TestGrp", "TestPt");
            bSendStatus = NRKSdk.ExecuteStep();

            // AddFunctTreeItem(MP_PF_ASK_USER_STRING,_T("Ask for String"),IDI_MP_PROCESS_FLOW_QUESTION,TRUE,ret1, 1);
            // AddFunctArg(MP_PF_ASK_USER_STRING,MP_ARG_STRING,_T("Question to ask"));
            // AddFunctArg(MP_PF_ASK_USER_STRING,MP_ARG_STRING,_T("Initial Answer"));
            // AddFunctArg(MP_PF_ASK_USER_STRING,MP_ARG_STRING,_T("Answer"),TRUE);

            NRKSdk.SetStep("Ask for String");
            NRKSdk.SetStringArg("Question to ask", "Enter Sphere Name");
            // NOTE: Should be "Initial Answer"... mistake added for error checking!
            NRKSdk.SetStringArg("Initial Value", "MyCoolSphere");
            bSendStatus = NRKSdk.ExecuteStep();

            if (bSendStatus)
            {
                int rCode = 0;
                NRKSdk.GetMPStepResult(ref rCode);
                if (rCode == (int) MPStatus.SdkError)
                {
                    //CStringArray msgs;
                    //// Something went wrong... check for any messages provided...
                    Object obj = null;
                    if (NRKSdk.GetMPStepMessages(ref obj))
                    {
                        string msg = "";
                        Array msgs = (Array) obj;
                        for (int i = 0; i < msgs.Length; i++)
                        {
                            msg += (String) msgs.GetValue(i);
                            msg += "\n";
                            //Console.WriteLine(msg);
                        }
                        MessageBox.Show(msg);
                    }
                }
            }

            // Now do the command correctly...
            NRKSdk.SetStep("Ask for String");
            NRKSdk.SetStringArg("Question to ask", "Enter Sphere Name");
            NRKSdk.SetStringArg("Initial Answer", "MyCoolSphere");
            bSendStatus = NRKSdk.ExecuteStep();

            if (bSendStatus)
            {
                int rCode = 0;
                NRKSdk.GetMPStepResult(ref rCode);
                if (rCode != (int) MPStatus.DoneSuccess)
                {
                    return;
                }
            }

            String sphereName = null;
	        if (bSendStatus && !NRKSdk.GetStringArg("Answer", ref sphereName))
            {
                return;
            }

            // AddFunctTreeItem(MP_PF_ASK_USER_DOUBLE,_T("Ask for Double"),IDI_MP_PROCESS_FLOW_QUESTION,TRUE,ret1, 1);
            // AddFunctArg(MP_PF_ASK_USER_DOUBLE,MP_ARG_STRING,_T("Question to ask"));
            // AddFunctArg(MP_PF_ASK_USER_DOUBLE,MP_ARG_DOUBLE,_T("Initial Value"));
            // AddFunctArg(MP_PF_ASK_USER_DOUBLE,MP_ARG_DOUBLE,_T("Answer"),TRUE);
            NRKSdk.SetStep("Ask for Double");
            NRKSdk.SetStringArg("Question to ask", "Enter Sphere Radius");
            NRKSdk.SetDoubleArg("Initial Value", 11.5);
            bSendStatus = NRKSdk.ExecuteStep();

            double radius = 0.0;
            if (bSendStatus && !NRKSdk.GetDoubleArg("Answer", ref radius))
            {
                return;
            }

            // AddFunctTreeItem(MP_CONSTRUCT_SPHERE,_T("Construct Sphere"),IDI_MP_DEFAULT,TRUE,ret2);
            // AddFunctArg(MP_CONSTRUCT_SPHERE,MP_ARG_OBJECT_NAME,_T("Sphere Name"));
            // AddFunctArg(MP_CONSTRUCT_SPHERE,MP_ARG_VECTOR,_T("Sphere Center (in working coordinates)"));
            // AddFunctArg(MP_CONSTRUCT_SPHERE,MP_ARG_DOUBLE,_T("Sphere Radius"));

            NRKSdk.SetStep("Construct Sphere");
            NRKSdk.SetObjectNameArg("Sphere Name", sphereName);
            NRKSdk.SetVectorArg("Sphere Center (in working coordinates)", 6.0, 12.0, 18.0);
            NRKSdk.SetDoubleArg("Sphere Radius", radius);
            bSendStatus = NRKSdk.ExecuteStep();

            // AddFunctTreeItem(MP_CONSTRUCT_POINT_OBJECT_ORIGIN,_T("Construct Point at Object Origin"),IDI_MP_DEFAULT,TRUE,ret2,1);
            // AddFunctArg(MP_CONSTRUCT_POINT_OBJECT_ORIGIN,MP_ARG_COL_OBJECT_NAME,_T("Object Name"));
            // AddFunctArg(MP_CONSTRUCT_POINT_OBJECT_ORIGIN,MP_ARG_POINT_NAME,_T("Resultant Point Name"));
            // AddFunctArg(MP_CONSTRUCT_POINT_OBJECT_ORIGIN,MP_ARG_VECTOR,_T("Vector Representation"),TRUE);
            // AddFunctArg(MP_CONSTRUCT_POINT_OBJECT_ORIGIN,MP_ARG_DOUBLE,_T("X Value"),TRUE);
            // AddFunctArg(MP_CONSTRUCT_POINT_OBJECT_ORIGIN,MP_ARG_DOUBLE,_T("Y Value"),TRUE);
            // AddFunctArg(MP_CONSTRUCT_POINT_OBJECT_ORIGIN,MP_ARG_DOUBLE,_T("Z Value"),TRUE);

            NRKSdk.SetStep("Construct Point at Object Origin");
            NRKSdk.SetCollectionObjectNameArg("Object Name", "", sphereName);
            NRKSdk.SetPointNameArg("Resultant Point Name", "", "TestGrp", "ObjOrgPt");
            bSendStatus = NRKSdk.ExecuteStep();

            double val = 0.0;
            if (bSendStatus && NRKSdk.GetDoubleArg("X Value", ref val))
            {
                string msg = "X Value: ";
                msg += val;
                MessageBox.Show(msg);
            }

            if (bSendStatus && NRKSdk.GetDoubleArg("Y Value", ref val))
            {
                string msg = "Y Value: ";
                msg += val;
                MessageBox.Show(msg);
            }

            if (bSendStatus && NRKSdk.GetDoubleArg("Z Value", ref val))
            {
                string msg = "Z Value: ";
                msg += val;
                MessageBox.Show(msg);
            }

            double xVal, yVal, zVal;
            xVal = yVal = zVal = 0.0;
            if (bSendStatus && NRKSdk.GetVectorArg("Vector Representation", ref xVal, ref yVal, ref zVal))
            {
                string msg = "Vector Value: ";
                msg += xVal;
                msg += " ";
                msg += yVal;
                msg += " ";
                msg += zVal;
                MessageBox.Show(msg);
            }

            //////////////////////////////////////////////////////////////////////////////////////////
	        // Test out working with transforms
	        //////////////////////////////////////////////////////////////////////////////////////////

	        // AddFunctTreeItem(MP_MAKE_TRANSFORM_DOUBLES,_T("Make a Transform from Doubles (Fixed XYZ)"),IDI_MP_MAKEITEM,TRUE,ret2);
	        //     AddFunctArg(MP_MAKE_TRANSFORM_DOUBLES,MP_ARG_DOUBLE,_T("X"));
	        //     AddFunctArg(MP_MAKE_TRANSFORM_DOUBLES,MP_ARG_DOUBLE,_T("Y"));
	        //     AddFunctArg(MP_MAKE_TRANSFORM_DOUBLES,MP_ARG_DOUBLE,_T("Z"));
	        //     AddFunctArg(MP_MAKE_TRANSFORM_DOUBLES,MP_ARG_DOUBLE,_T("Rx (Roll)"));
	        //     AddFunctArg(MP_MAKE_TRANSFORM_DOUBLES,MP_ARG_DOUBLE,_T("Ry (Pitch)"));
	        //     AddFunctArg(MP_MAKE_TRANSFORM_DOUBLES,MP_ARG_DOUBLE,_T("Rz (Yaw)"));
	        //     AddFunctArg(MP_MAKE_TRANSFORM_DOUBLES,MP_ARG_TRANSFORM,_T("Resultant Transform"),TRUE);

	        NRKSdk.SetStep("Make a Transform from Doubles (Fixed XYZ)");
	        NRKSdk.SetDoubleArg("X", 10.0);
	        NRKSdk.SetDoubleArg("Y", 30.0);
	        NRKSdk.SetDoubleArg("Z", 50.0);
	        NRKSdk.SetDoubleArg("Rx (Roll)", 40.0);
	        NRKSdk.SetDoubleArg("Ry (Pitch)", -30.0);
	        NRKSdk.SetDoubleArg("Rz (Yaw)", -60.0);
	        bSendStatus = NRKSdk.ExecuteStep();

	        if (bSendStatus)
	        {
                Object vMatrix = null;
		        if (NRKSdk.GetTransformArg("Resultant Transform", ref vMatrix))
		        {
                    // Setup the matrix for use with SDK method
                    VariantWrapper matrixobj = new VariantWrapper(vMatrix);
                    Object objMatrix = matrixobj;

                    // AddFunctTreeItem(MP_CONSTRUCT_FRAME,_T("Construct Frame"),IDI_MP_DEFAULT,TRUE,ret2,1);
                    // AddFunctArg(MP_CONSTRUCT_FRAME,MP_ARG_COL_OBJECT_NAME,_T("New Frame Name"), FALSE);
                    // AddFunctArg(MP_CONSTRUCT_FRAME,MP_ARG_TRANSFORM,_T("Transform in Working Coordinates"));

                    NRKSdk.SetStep("Construct Frame");
                    NRKSdk.SetCollectionObjectNameArg("New Frame Name", "", "Test Frame");
                    NRKSdk.SetTransformArg("Transform in Working Coordinates", ref objMatrix);
                    bSendStatus = NRKSdk.ExecuteStep();
                }
            }

            // AddFunctTreeItem(MP_GET_TRANSFORM_FROM_OBJECT,_T("Get Working Transform of Object (Fixed XYZ)"),IDI_MP_MAKEITEM,TRUE,ret2);
	        // AddFunctArg(MP_GET_TRANSFORM_FROM_OBJECT,MP_ARG_COL_OBJECT_NAME,_T("Object Name"));
	        // AddFunctArg(MP_GET_TRANSFORM_FROM_OBJECT,MP_ARG_TRANSFORM,_T("Transform"),TRUE);

	        NRKSdk.SetStep("Get Working Transform of Object (Fixed XYZ)");
	        NRKSdk.SetCollectionObjectNameArg("Object Name", "", sphereName);
	        bSendStatus = NRKSdk.ExecuteStep();

	        if (bSendStatus)
	        {
		        int rCode = 0;
		        NRKSdk.GetMPStepResult(ref rCode);
		        if (rCode == (int) MPStatus.DoneSuccess)
		        {
			        Object vMatrix = null;
			        if (NRKSdk.GetTransformArg("Transform", ref vMatrix))
			        {
                        Array matrix = (Array) vMatrix;

				        int lXstart, lXend;
				        int lYstart, lYend;
				        int row = -1;
				        int col = -1;

				        lXstart = matrix.GetLowerBound(0);
				        lXend   = matrix.GetUpperBound(0);
				        lYstart = matrix.GetLowerBound(1);
				        lYend   = matrix.GetUpperBound(1);

                        double[,] T = new double[lXend + 1, lYend+1];
                        for (row = lXstart; row <= lXend; row++)
				        {
                            for (col = lYstart; col <= lYend; col++)
					        {	
						        double element;
                                element = (double)matrix.GetValue(row, col);
                                T[row, col] = element;
					        }
				        }
			        }
		        }
	        }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            NRKSdk = null;
            GC.Collect();
        }

        public void KillExistingSASDK()
        {
            foreach (Process p in Process.GetProcesses("."))
            {
                try
                {
                    string processName = p.ProcessName.ToLower();
                    if (processName.Contains("spatialanalyzersdk"))
                    {
                        p.Kill();
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message.ToString());
                }
            }
        }

        // olga 2020.10.22 XIT-2275 - Export ASCII Points
        private void button4_Click(object sender, EventArgs e)
        {
            if (NRKSdk == null)
            {
                return;
            }
            // Export point group
            NRKSdk.SetStep("Export ASCII Points");
            NRKSdk.SetFilePathArg(("ASCII File Path"), ("C:\\Temp\\MP\\pts.txt"), false);

            object grpNameList = new System.Collections.ArrayList();
	        ((System.Collections.ArrayList)grpNameList).Add("B::circle");

            Object vGrpList = new System.Runtime.InteropServices.VariantWrapper(((System.Collections.ArrayList)grpNameList).ToArray());

            NRKSdk.SetCollectionGroupNameRefListArg(("Group Names to export"), ref vGrpList);
            NRKSdk.SetExportDataDelimeterTypeArg(("Data Delimiter"), ("Comma"));
            NRKSdk.SetExportTargetNameFormatArg(("Target Name Format"), ("Group Target"));
            NRKSdk.SetCoordinateSystemTypeArg(("Desired Coordinate System"), ("Cartesian"));
            NRKSdk.SetBoolArg(("Include Target Offsets?"), false);
            NRKSdk.SetBoolArg(("Include Target Comments?"), false);
            NRKSdk.SetBoolArg(("Include Timestamps?"), false);
            NRKSdk.SetBoolArg(("Include Tolerances?"), false);
            NRKSdk.SetBoolArg(("Include Coordinate Uncertainties?"), false);
            NRKSdk.SetBoolArg(("Include SA version and frame comments?"), true);
            NRKSdk.SetBoolArg(("Include Axis Comments?"), true);
            NRKSdk.SetBoolArg(("Include Export Format Info?"), true);
            NRKSdk.SetBoolArg(("Include Weights?"), false);
            NRKSdk.SetBoolArg(("Include Measurement Details?"), false);
            NRKSdk.SetBoolArg(("Maximum Precision (Scientific Notation)?"), false);
            NRKSdk.SetIntegerArg(("Decimal Precision"), 6);
            NRKSdk.SetBoolArg(("Append?"), false);
            bool bSendStatus = NRKSdk.ExecuteStep();

            if (bSendStatus)
            {
                int rCode = 0;
                NRKSdk.GetMPStepResult(ref rCode);
                if (rCode == (int)MPStatus.SdkError)
                {
                    //// Something went wrong... check for any messages provided...
                    Object obj = null;
                    if (NRKSdk.GetMPStepMessages(ref obj))
                    {
                        string msg = "";
                        Array msgs = (Array)obj;
                        for (int i = 0; i < msgs.Length; i++)
                        {
                            msg += (String)msgs.GetValue(i);
                            msg += "\n";
                            //Console.WriteLine(msg);
                        }
                        MessageBox.Show(msg);
                    }
                }
            }

        }
    }
}